zoukankan      html  css  js  c++  java
  • [CF852D] Exploration plan

    问题描述

    The competitors of Bubble Cup X gathered after the competition and discussed what is the best way to get to know the host country and its cities.

    After exploring the map of Serbia for a while, the competitors came up with the following facts: the country has V cities which are indexed with numbers from 1 to V, and there are E bi-directional roads that connect the cites. Each road has a weight (the time needed to cross that road). There are N teams at the Bubble Cup and the competitors came up with the following plan: each of the N teams will start their journey in one of the V cities, and some of the teams share the starting position.

    They want to find the shortest time T, such that every team can move in these T minutes, and the number of different cities they end up in is at least K (because they will only get to know the cities they end up in). A team doesn't have to be on the move all the time, if they like it in a particular city, they can stay there and wait for the time to pass.

    Please help the competitors to determine the shortest time T so it's possible for them to end up in at least K different cities or print -1 if that is impossible no matter how they move.

    Note that there can exist multiple roads between some cities.

    输入格式

    The first line contains four integers: V, E, N and K (1 ≤  V  ≤  600,  1  ≤  E  ≤  20000,  1  ≤  N  ≤  min(V, 200),  1  ≤  K  ≤  N), number of cities, number of roads, number of teams and the smallest number of different cities they need to end up in, respectively.

    The second line contains N integers, the cities where the teams start their journey.

    Next E lines contain information about the roads in following format: Ai Bi Ti (1 ≤ Ai, Bi ≤ V,  1 ≤ Ti ≤ 10000), which means that there is a road connecting cities Ai and Bi, and you need Ti minutes to cross that road.

    输出格式

    Output a single integer that represents the minimal time the teams can move for, such that they end up in at least K different cities or output -1 if there is no solution.

    If the solution exists, result will be no greater than 1731311.

    样例输入

    6 7 5 4
    5 5 2 2 5
    1 3 3
    1 5 2
    1 6 5
    2 5 4
    2 6 7
    3 4 11
    3 5 3

    样例输出

    3

    样例解释

    Three teams start from city 5, and two teams start from city 2. If they agree to move for 3 minutes, one possible situation would be the following: Two teams in city 2, one team in city 5, one team in city 3 , and one team in city 1. And we see that there are four different cities the teams end their journey at.

    题目大意

    给定一个 v个点 e条边的带权无向图,在图上有 n个人,第 i个人位于点 xi,一个人通过一条边需要花费这条边的边权的时间。

    现在每个人可以自由地走。求最短多少时间后满足结束后有人的节点数 ≥ m

    解析

    观察到最后的答案就是走过的最长时间。那么,这就变成了一个最大值最小的问题,可以用二分答案解决。

    二分需要的时间mid。因为最后是至少m做城市有人,所以不妨当做是用m个人去匹配m座城市,那么就变成了一个二分图匹配问题。对于每个人,向他所在的城市在mid时间内可以到达的城市连边,这可以用Floyd求出两两最短路得到。然后二分图匹配,如果匹配数大于等于m说明可行。

    代码

    #include <iostream>
    #include <cstdio>
    #include <cstring>
    #define N 1202
    using namespace std;
    int v,e,n,m,i,j,k,dis[N][N],g[N][N],pos[N],match[N];
    bool vis[N];
    int read()
    {
    	char c=getchar();
    	int w=0;
    	while(c<'0'||c>'9') c=getchar();
    	while(c<='9'&&c>='0'){
    		w=w*10+c-'0';
    		c=getchar();
    	}
    	return w;
    }
    bool dfs(int x)
    {
    	for(int y=1;y<=v;y++){
    		if(g[x][y]&&!vis[y]){
    			vis[y]=1;
    			if(!match[y]||dfs(match[y])){
    				match[y]=x;
    				return 1;
    			}
    		}
    	}
    	return 0;
    }
    int hungary()
    {
    	memset(match,0,sizeof(match));
    	int ans=0;
    	for(int i=1;i<=n;i++){
    		memset(vis,0,sizeof(vis));
    		if(dfs(i)) ans++;
    	}
    	return ans;
    }
    bool check(int x)
    {
    	memset(g,0,sizeof(g));
    	for(int i=1;i<=n;i++){
    		for(int j=1;j<=v;j++){
    			if(dis[pos[i]][j]<=x) g[i][j]=1;
    		}
    	}
    	int ans=hungary();
    	return (ans>=m);
    }
    int main()
    {
    	v=read();e=read();n=read();m=read();
    	for(i=1;i<=n;i++) pos[i]=read();
    	memset(dis,0x3f,sizeof(dis));
    	for(i=1;i<=v;i++) dis[i][i]=0;
    	for(i=1;i<=e;i++){
    		int u=read(),v=read(),w=read();
    		dis[u][v]=dis[v][u]=min(dis[u][v],w);
    	}
    	for(k=1;k<=v;k++){
    		for(i=1;i<=v;i++){
    			for(j=1;j<=v;j++) dis[i][j]=min(dis[i][j],dis[i][k]+dis[k][j]);
    		}
    	}
    	int l=0,r=1731311,mid,ans=-1;
    	while(l<=r){
    		mid=(l+r)/2;
    		if(check(mid)){
    			ans=mid;
    			r=mid-1;
    		}
    		else l=mid+1;
    	}
    	printf("%d
    ",ans);
    	return 0;
    }
    
  • 相关阅读:
    时间处理得到UTC时间
    java数据同步陷阱
    360公司2016笔试题
    YTU 1439: 2.4.5 Fractions to Decimals 分数化小数
    YTU 2422: C语言习题 n个数逆序
    YTU 2421: C语言习题 矩形法求定积分
    YTU 2427: C语言习题 整数排序
    YTU 2832: 使用指针访问数组元素--程序填空
    YTU 1050: 写一个函数,使给定的一个二维数组(3×3)转置,即行列互换
    HDU 1069:Monkey and Banana
  • 原文地址:https://www.cnblogs.com/LSlzf/p/11684857.html
Copyright © 2011-2022 走看看